package com.neusoft.smart.pos.card.persistent.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CardCapitalChangeExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer offset;

    private Integer limit;

    public CardCapitalChangeExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }

    public Integer getOffset() {
        return this.offset;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getLimit() {
        return this.limit;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public CardCapitalChangeExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andAmountChangeIdIsNull() {
            addCriterion("amount_change_id is null");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdIsNotNull() {
            addCriterion("amount_change_id is not null");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdEqualTo(Integer value) {
            addCriterion("amount_change_id =", value, "amountChangeId");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdNotEqualTo(Integer value) {
            addCriterion("amount_change_id <>", value, "amountChangeId");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdGreaterThan(Integer value) {
            addCriterion("amount_change_id >", value, "amountChangeId");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("amount_change_id >=", value, "amountChangeId");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdLessThan(Integer value) {
            addCriterion("amount_change_id <", value, "amountChangeId");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdLessThanOrEqualTo(Integer value) {
            addCriterion("amount_change_id <=", value, "amountChangeId");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdIn(List<Integer> values) {
            addCriterion("amount_change_id in", values, "amountChangeId");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdNotIn(List<Integer> values) {
            addCriterion("amount_change_id not in", values, "amountChangeId");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdBetween(Integer value1, Integer value2) {
            addCriterion("amount_change_id between", value1, value2, "amountChangeId");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIdNotBetween(Integer value1, Integer value2) {
            addCriterion("amount_change_id not between", value1, value2, "amountChangeId");
            return (Criteria) this;
        }

        public Criteria andCardIdIsNull() {
            addCriterion("card_id is null");
            return (Criteria) this;
        }

        public Criteria andCardIdIsNotNull() {
            addCriterion("card_id is not null");
            return (Criteria) this;
        }

        public Criteria andCardIdEqualTo(Integer value) {
            addCriterion("card_id =", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdNotEqualTo(Integer value) {
            addCriterion("card_id <>", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdGreaterThan(Integer value) {
            addCriterion("card_id >", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("card_id >=", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdLessThan(Integer value) {
            addCriterion("card_id <", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdLessThanOrEqualTo(Integer value) {
            addCriterion("card_id <=", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdIn(List<Integer> values) {
            addCriterion("card_id in", values, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdNotIn(List<Integer> values) {
            addCriterion("card_id not in", values, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdBetween(Integer value1, Integer value2) {
            addCriterion("card_id between", value1, value2, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdNotBetween(Integer value1, Integer value2) {
            addCriterion("card_id not between", value1, value2, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardNumIsNull() {
            addCriterion("card_num is null");
            return (Criteria) this;
        }

        public Criteria andCardNumIsNotNull() {
            addCriterion("card_num is not null");
            return (Criteria) this;
        }

        public Criteria andCardNumEqualTo(String value) {
            addCriterion("card_num =", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumNotEqualTo(String value) {
            addCriterion("card_num <>", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumGreaterThan(String value) {
            addCriterion("card_num >", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumGreaterThanOrEqualTo(String value) {
            addCriterion("card_num >=", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumLessThan(String value) {
            addCriterion("card_num <", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumLessThanOrEqualTo(String value) {
            addCriterion("card_num <=", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumLike(String value) {
            addCriterion("card_num like", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumNotLike(String value) {
            addCriterion("card_num not like", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumIn(List<String> values) {
            addCriterion("card_num in", values, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumNotIn(List<String> values) {
            addCriterion("card_num not in", values, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumBetween(String value1, String value2) {
            addCriterion("card_num between", value1, value2, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumNotBetween(String value1, String value2) {
            addCriterion("card_num not between", value1, value2, "cardNum");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdIsNull() {
            addCriterion("change_order_id is null");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdIsNotNull() {
            addCriterion("change_order_id is not null");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdEqualTo(String value) {
            addCriterion("change_order_id =", value, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdNotEqualTo(String value) {
            addCriterion("change_order_id <>", value, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdGreaterThan(String value) {
            addCriterion("change_order_id >", value, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdGreaterThanOrEqualTo(String value) {
            addCriterion("change_order_id >=", value, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdLessThan(String value) {
            addCriterion("change_order_id <", value, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdLessThanOrEqualTo(String value) {
            addCriterion("change_order_id <=", value, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdLike(String value) {
            addCriterion("change_order_id like", value, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdNotLike(String value) {
            addCriterion("change_order_id not like", value, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdIn(List<String> values) {
            addCriterion("change_order_id in", values, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdNotIn(List<String> values) {
            addCriterion("change_order_id not in", values, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdBetween(String value1, String value2) {
            addCriterion("change_order_id between", value1, value2, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andChangeOrderIdNotBetween(String value1, String value2) {
            addCriterion("change_order_id not between", value1, value2, "changeOrderId");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIsNull() {
            addCriterion("amount_change is null");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIsNotNull() {
            addCriterion("amount_change is not null");
            return (Criteria) this;
        }

        public Criteria andAmountChangeEqualTo(Long value) {
            addCriterion("amount_change =", value, "amountChange");
            return (Criteria) this;
        }

        public Criteria andAmountChangeNotEqualTo(Long value) {
            addCriterion("amount_change <>", value, "amountChange");
            return (Criteria) this;
        }

        public Criteria andAmountChangeGreaterThan(Long value) {
            addCriterion("amount_change >", value, "amountChange");
            return (Criteria) this;
        }

        public Criteria andAmountChangeGreaterThanOrEqualTo(Long value) {
            addCriterion("amount_change >=", value, "amountChange");
            return (Criteria) this;
        }

        public Criteria andAmountChangeLessThan(Long value) {
            addCriterion("amount_change <", value, "amountChange");
            return (Criteria) this;
        }

        public Criteria andAmountChangeLessThanOrEqualTo(Long value) {
            addCriterion("amount_change <=", value, "amountChange");
            return (Criteria) this;
        }

        public Criteria andAmountChangeIn(List<Long> values) {
            addCriterion("amount_change in", values, "amountChange");
            return (Criteria) this;
        }

        public Criteria andAmountChangeNotIn(List<Long> values) {
            addCriterion("amount_change not in", values, "amountChange");
            return (Criteria) this;
        }

        public Criteria andAmountChangeBetween(Long value1, Long value2) {
            addCriterion("amount_change between", value1, value2, "amountChange");
            return (Criteria) this;
        }

        public Criteria andAmountChangeNotBetween(Long value1, Long value2) {
            addCriterion("amount_change not between", value1, value2, "amountChange");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeIsNull() {
            addCriterion("amount_before is null");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeIsNotNull() {
            addCriterion("amount_before is not null");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeEqualTo(Long value) {
            addCriterion("amount_before =", value, "amountBefore");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeNotEqualTo(Long value) {
            addCriterion("amount_before <>", value, "amountBefore");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeGreaterThan(Long value) {
            addCriterion("amount_before >", value, "amountBefore");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeGreaterThanOrEqualTo(Long value) {
            addCriterion("amount_before >=", value, "amountBefore");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeLessThan(Long value) {
            addCriterion("amount_before <", value, "amountBefore");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeLessThanOrEqualTo(Long value) {
            addCriterion("amount_before <=", value, "amountBefore");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeIn(List<Long> values) {
            addCriterion("amount_before in", values, "amountBefore");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeNotIn(List<Long> values) {
            addCriterion("amount_before not in", values, "amountBefore");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeBetween(Long value1, Long value2) {
            addCriterion("amount_before between", value1, value2, "amountBefore");
            return (Criteria) this;
        }

        public Criteria andAmountBeforeNotBetween(Long value1, Long value2) {
            addCriterion("amount_before not between", value1, value2, "amountBefore");
            return (Criteria) this;
        }

        public Criteria andAmountAfterIsNull() {
            addCriterion("amount_after is null");
            return (Criteria) this;
        }

        public Criteria andAmountAfterIsNotNull() {
            addCriterion("amount_after is not null");
            return (Criteria) this;
        }

        public Criteria andAmountAfterEqualTo(Long value) {
            addCriterion("amount_after =", value, "amountAfter");
            return (Criteria) this;
        }

        public Criteria andAmountAfterNotEqualTo(Long value) {
            addCriterion("amount_after <>", value, "amountAfter");
            return (Criteria) this;
        }

        public Criteria andAmountAfterGreaterThan(Long value) {
            addCriterion("amount_after >", value, "amountAfter");
            return (Criteria) this;
        }

        public Criteria andAmountAfterGreaterThanOrEqualTo(Long value) {
            addCriterion("amount_after >=", value, "amountAfter");
            return (Criteria) this;
        }

        public Criteria andAmountAfterLessThan(Long value) {
            addCriterion("amount_after <", value, "amountAfter");
            return (Criteria) this;
        }

        public Criteria andAmountAfterLessThanOrEqualTo(Long value) {
            addCriterion("amount_after <=", value, "amountAfter");
            return (Criteria) this;
        }

        public Criteria andAmountAfterIn(List<Long> values) {
            addCriterion("amount_after in", values, "amountAfter");
            return (Criteria) this;
        }

        public Criteria andAmountAfterNotIn(List<Long> values) {
            addCriterion("amount_after not in", values, "amountAfter");
            return (Criteria) this;
        }

        public Criteria andAmountAfterBetween(Long value1, Long value2) {
            addCriterion("amount_after between", value1, value2, "amountAfter");
            return (Criteria) this;
        }

        public Criteria andAmountAfterNotBetween(Long value1, Long value2) {
            addCriterion("amount_after not between", value1, value2, "amountAfter");
            return (Criteria) this;
        }

        public Criteria andPointChangeIsNull() {
            addCriterion("point_change is null");
            return (Criteria) this;
        }

        public Criteria andPointChangeIsNotNull() {
            addCriterion("point_change is not null");
            return (Criteria) this;
        }

        public Criteria andPointChangeEqualTo(Integer value) {
            addCriterion("point_change =", value, "pointChange");
            return (Criteria) this;
        }

        public Criteria andPointChangeNotEqualTo(Integer value) {
            addCriterion("point_change <>", value, "pointChange");
            return (Criteria) this;
        }

        public Criteria andPointChangeGreaterThan(Integer value) {
            addCriterion("point_change >", value, "pointChange");
            return (Criteria) this;
        }

        public Criteria andPointChangeGreaterThanOrEqualTo(Integer value) {
            addCriterion("point_change >=", value, "pointChange");
            return (Criteria) this;
        }

        public Criteria andPointChangeLessThan(Integer value) {
            addCriterion("point_change <", value, "pointChange");
            return (Criteria) this;
        }

        public Criteria andPointChangeLessThanOrEqualTo(Integer value) {
            addCriterion("point_change <=", value, "pointChange");
            return (Criteria) this;
        }

        public Criteria andPointChangeIn(List<Integer> values) {
            addCriterion("point_change in", values, "pointChange");
            return (Criteria) this;
        }

        public Criteria andPointChangeNotIn(List<Integer> values) {
            addCriterion("point_change not in", values, "pointChange");
            return (Criteria) this;
        }

        public Criteria andPointChangeBetween(Integer value1, Integer value2) {
            addCriterion("point_change between", value1, value2, "pointChange");
            return (Criteria) this;
        }

        public Criteria andPointChangeNotBetween(Integer value1, Integer value2) {
            addCriterion("point_change not between", value1, value2, "pointChange");
            return (Criteria) this;
        }

        public Criteria andPointBeforeIsNull() {
            addCriterion("point_before is null");
            return (Criteria) this;
        }

        public Criteria andPointBeforeIsNotNull() {
            addCriterion("point_before is not null");
            return (Criteria) this;
        }

        public Criteria andPointBeforeEqualTo(Integer value) {
            addCriterion("point_before =", value, "pointBefore");
            return (Criteria) this;
        }

        public Criteria andPointBeforeNotEqualTo(Integer value) {
            addCriterion("point_before <>", value, "pointBefore");
            return (Criteria) this;
        }

        public Criteria andPointBeforeGreaterThan(Integer value) {
            addCriterion("point_before >", value, "pointBefore");
            return (Criteria) this;
        }

        public Criteria andPointBeforeGreaterThanOrEqualTo(Integer value) {
            addCriterion("point_before >=", value, "pointBefore");
            return (Criteria) this;
        }

        public Criteria andPointBeforeLessThan(Integer value) {
            addCriterion("point_before <", value, "pointBefore");
            return (Criteria) this;
        }

        public Criteria andPointBeforeLessThanOrEqualTo(Integer value) {
            addCriterion("point_before <=", value, "pointBefore");
            return (Criteria) this;
        }

        public Criteria andPointBeforeIn(List<Integer> values) {
            addCriterion("point_before in", values, "pointBefore");
            return (Criteria) this;
        }

        public Criteria andPointBeforeNotIn(List<Integer> values) {
            addCriterion("point_before not in", values, "pointBefore");
            return (Criteria) this;
        }

        public Criteria andPointBeforeBetween(Integer value1, Integer value2) {
            addCriterion("point_before between", value1, value2, "pointBefore");
            return (Criteria) this;
        }

        public Criteria andPointBeforeNotBetween(Integer value1, Integer value2) {
            addCriterion("point_before not between", value1, value2, "pointBefore");
            return (Criteria) this;
        }

        public Criteria andPointAfterIsNull() {
            addCriterion("point_after is null");
            return (Criteria) this;
        }

        public Criteria andPointAfterIsNotNull() {
            addCriterion("point_after is not null");
            return (Criteria) this;
        }

        public Criteria andPointAfterEqualTo(Integer value) {
            addCriterion("point_after =", value, "pointAfter");
            return (Criteria) this;
        }

        public Criteria andPointAfterNotEqualTo(Integer value) {
            addCriterion("point_after <>", value, "pointAfter");
            return (Criteria) this;
        }

        public Criteria andPointAfterGreaterThan(Integer value) {
            addCriterion("point_after >", value, "pointAfter");
            return (Criteria) this;
        }

        public Criteria andPointAfterGreaterThanOrEqualTo(Integer value) {
            addCriterion("point_after >=", value, "pointAfter");
            return (Criteria) this;
        }

        public Criteria andPointAfterLessThan(Integer value) {
            addCriterion("point_after <", value, "pointAfter");
            return (Criteria) this;
        }

        public Criteria andPointAfterLessThanOrEqualTo(Integer value) {
            addCriterion("point_after <=", value, "pointAfter");
            return (Criteria) this;
        }

        public Criteria andPointAfterIn(List<Integer> values) {
            addCriterion("point_after in", values, "pointAfter");
            return (Criteria) this;
        }

        public Criteria andPointAfterNotIn(List<Integer> values) {
            addCriterion("point_after not in", values, "pointAfter");
            return (Criteria) this;
        }

        public Criteria andPointAfterBetween(Integer value1, Integer value2) {
            addCriterion("point_after between", value1, value2, "pointAfter");
            return (Criteria) this;
        }

        public Criteria andPointAfterNotBetween(Integer value1, Integer value2) {
            addCriterion("point_after not between", value1, value2, "pointAfter");
            return (Criteria) this;
        }

        public Criteria andChangeTypeIsNull() {
            addCriterion("change_type is null");
            return (Criteria) this;
        }

        public Criteria andChangeTypeIsNotNull() {
            addCriterion("change_type is not null");
            return (Criteria) this;
        }

        public Criteria andChangeTypeEqualTo(Integer value) {
            addCriterion("change_type =", value, "changeType");
            return (Criteria) this;
        }

        public Criteria andChangeTypeNotEqualTo(Integer value) {
            addCriterion("change_type <>", value, "changeType");
            return (Criteria) this;
        }

        public Criteria andChangeTypeGreaterThan(Integer value) {
            addCriterion("change_type >", value, "changeType");
            return (Criteria) this;
        }

        public Criteria andChangeTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("change_type >=", value, "changeType");
            return (Criteria) this;
        }

        public Criteria andChangeTypeLessThan(Integer value) {
            addCriterion("change_type <", value, "changeType");
            return (Criteria) this;
        }

        public Criteria andChangeTypeLessThanOrEqualTo(Integer value) {
            addCriterion("change_type <=", value, "changeType");
            return (Criteria) this;
        }

        public Criteria andChangeTypeIn(List<Integer> values) {
            addCriterion("change_type in", values, "changeType");
            return (Criteria) this;
        }

        public Criteria andChangeTypeNotIn(List<Integer> values) {
            addCriterion("change_type not in", values, "changeType");
            return (Criteria) this;
        }

        public Criteria andChangeTypeBetween(Integer value1, Integer value2) {
            addCriterion("change_type between", value1, value2, "changeType");
            return (Criteria) this;
        }

        public Criteria andChangeTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("change_type not between", value1, value2, "changeType");
            return (Criteria) this;
        }

        public Criteria andChangeTimeIsNull() {
            addCriterion("change_time is null");
            return (Criteria) this;
        }

        public Criteria andChangeTimeIsNotNull() {
            addCriterion("change_time is not null");
            return (Criteria) this;
        }

        public Criteria andChangeTimeEqualTo(Date value) {
            addCriterion("change_time =", value, "changeTime");
            return (Criteria) this;
        }

        public Criteria andChangeTimeNotEqualTo(Date value) {
            addCriterion("change_time <>", value, "changeTime");
            return (Criteria) this;
        }

        public Criteria andChangeTimeGreaterThan(Date value) {
            addCriterion("change_time >", value, "changeTime");
            return (Criteria) this;
        }

        public Criteria andChangeTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("change_time >=", value, "changeTime");
            return (Criteria) this;
        }

        public Criteria andChangeTimeLessThan(Date value) {
            addCriterion("change_time <", value, "changeTime");
            return (Criteria) this;
        }

        public Criteria andChangeTimeLessThanOrEqualTo(Date value) {
            addCriterion("change_time <=", value, "changeTime");
            return (Criteria) this;
        }

        public Criteria andChangeTimeIn(List<Date> values) {
            addCriterion("change_time in", values, "changeTime");
            return (Criteria) this;
        }

        public Criteria andChangeTimeNotIn(List<Date> values) {
            addCriterion("change_time not in", values, "changeTime");
            return (Criteria) this;
        }

        public Criteria andChangeTimeBetween(Date value1, Date value2) {
            addCriterion("change_time between", value1, value2, "changeTime");
            return (Criteria) this;
        }

        public Criteria andChangeTimeNotBetween(Date value1, Date value2) {
            addCriterion("change_time not between", value1, value2, "changeTime");
            return (Criteria) this;
        }

        public Criteria andIsActiveIsNull() {
            addCriterion("is_active is null");
            return (Criteria) this;
        }

        public Criteria andIsActiveIsNotNull() {
            addCriterion("is_active is not null");
            return (Criteria) this;
        }

        public Criteria andIsActiveEqualTo(Integer value) {
            addCriterion("is_active =", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveNotEqualTo(Integer value) {
            addCriterion("is_active <>", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveGreaterThan(Integer value) {
            addCriterion("is_active >", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_active >=", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveLessThan(Integer value) {
            addCriterion("is_active <", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveLessThanOrEqualTo(Integer value) {
            addCriterion("is_active <=", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveIn(List<Integer> values) {
            addCriterion("is_active in", values, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveNotIn(List<Integer> values) {
            addCriterion("is_active not in", values, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveBetween(Integer value1, Integer value2) {
            addCriterion("is_active between", value1, value2, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveNotBetween(Integer value1, Integer value2) {
            addCriterion("is_active not between", value1, value2, "isActive");
            return (Criteria) this;
        }

        public Criteria andContentIsNull() {
            addCriterion("content is null");
            return (Criteria) this;
        }

        public Criteria andContentIsNotNull() {
            addCriterion("content is not null");
            return (Criteria) this;
        }

        public Criteria andContentEqualTo(String value) {
            addCriterion("content =", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentNotEqualTo(String value) {
            addCriterion("content <>", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentGreaterThan(String value) {
            addCriterion("content >", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentGreaterThanOrEqualTo(String value) {
            addCriterion("content >=", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentLessThan(String value) {
            addCriterion("content <", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentLessThanOrEqualTo(String value) {
            addCriterion("content <=", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentLike(String value) {
            addCriterion("content like", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentNotLike(String value) {
            addCriterion("content not like", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentIn(List<String> values) {
            addCriterion("content in", values, "content");
            return (Criteria) this;
        }

        public Criteria andContentNotIn(List<String> values) {
            addCriterion("content not in", values, "content");
            return (Criteria) this;
        }

        public Criteria andContentBetween(String value1, String value2) {
            addCriterion("content between", value1, value2, "content");
            return (Criteria) this;
        }

        public Criteria andContentNotBetween(String value1, String value2) {
            addCriterion("content not between", value1, value2, "content");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeIsNull() {
            addCriterion("created_time is null");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeIsNotNull() {
            addCriterion("created_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeEqualTo(Date value) {
            addCriterion("created_time =", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeNotEqualTo(Date value) {
            addCriterion("created_time <>", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeGreaterThan(Date value) {
            addCriterion("created_time >", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("created_time >=", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeLessThan(Date value) {
            addCriterion("created_time <", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeLessThanOrEqualTo(Date value) {
            addCriterion("created_time <=", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeIn(List<Date> values) {
            addCriterion("created_time in", values, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeNotIn(List<Date> values) {
            addCriterion("created_time not in", values, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeBetween(Date value1, Date value2) {
            addCriterion("created_time between", value1, value2, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeNotBetween(Date value1, Date value2) {
            addCriterion("created_time not between", value1, value2, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}